#ifndef lint
static char sccsid[] = "@(#)tiff_compress.c	1.9 2/19/89";
#endif

/*
 * Copyright (c) 1988 by Sam Leffler.
 * All rights reserved.
 *
 * This file is provided for unrestricted use provided that this
 * legend is included on all tape media and as a part of the
 * software program in whole or part.  Users may copy, modify or
 * distribute this file at will.
 */

/*
 * TIFF Library
 *
 * Compression Scheme Configuration Support.
 */
#include "tiffio.h"

extern	int TIFFInitDumpMode();
extern	int TIFFInitCCITTRLE(), TIFFInitCCITTRLEW();
extern	int TIFFInitPackBits();
extern	int TIFFInitCCITTFax3(), TIFFInitCCITTFax4();
extern	int TIFFInitThunderScan();
#ifdef PICIO_SUPPORT
extern	int TIFFInitPicio();
#endif
extern	int TIFFInitLZW();

static	struct cscheme {
	int	scheme;
	int	(*init)();
} CompressionSchemes[] = {
    { COMPRESSION_NONE,		TIFFInitDumpMode },
    { COMPRESSION_LZW,		TIFFInitLZW },
    { COMPRESSION_PACKBITS,	TIFFInitPackBits },
#ifdef PICIO_SUPPORT
    { COMPRESSION_PICIO,	TIFFInitPicio },
#endif
    { COMPRESSION_THUNDERSCAN,	TIFFInitThunderScan },
    { COMPRESSION_CCITTRLE,	TIFFInitCCITTRLE },
    { COMPRESSION_CCITTRLEW,	TIFFInitCCITTRLEW },
    { COMPRESSION_CCITTFAX3,	TIFFInitCCITTFax3 },
    { COMPRESSION_CCITTFAX4,	TIFFInitCCITTFax4 },
};
#define	NSCHEMES (sizeof (CompressionSchemes) / sizeof (CompressionSchemes[0]))

TIFFSetCompressionScheme(tif, scheme)
	TIFF *tif;
	int scheme;
{
	register struct cscheme *c;

	for (c = CompressionSchemes; c < &CompressionSchemes[NSCHEMES]; c++)
		if (c->scheme == scheme)
			return (c->init ? (*c->init)(tif) : 1);
	TIFFError(tif->tif_name, "Unknown data compression algorithm %u (0x%x)",
	    scheme, scheme);
	return (0);
}
